Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jgroups.demos
Class QuoteServer

    java.lang.Object
      org.jgroups.demos.QuoteServer

All Implemented Interfaces:
  MembershipListener, MessageListener

    public class QuoteServer

extends java.lang.Object
implements MembershipListener, MessageListener

Example of a replicated quote server. The server maintains state which consists of a list of quotes and their corresponding values. When it is started, it tries to reach other quote servers to get its initial state. If it does not receive any response after 5 seconds, it assumes it is the first server and starts processing requests.

Any updates are multicast across the cluster

Author:
  Bela Ban

Constructor Summary
`QuoteServer()`

Method Summary
`void` | `block()` Called (usually by the FLUSH protocol), as an indication that the member should stop sending messages.
`java.util.Hashtable` | `getAllStocks()`
`float` | `getQuote(java.lang.String stock_name)`
`byte[]` | `getState()` Answers the group state; e.g., when joining.
`static void` | `main(java.lang.String[] args)`
`void` | `printAllStocks()`
`void` | `receive(Message msg)` Called when a message is received.
`void` | `setQuote(java.lang.String stock_name, java.lang.Float value)`
`void` | `setState(byte[] state)` Sets the group state; e.g., when joining.
`void` | `start()`
`void` | `suspect(Address suspected_mbr)` Called whenever a member is suspected of having crashed, but has not yet been excluded.
`void` | `viewAccepted(View new_view)` Called when a change in membership has occurred.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### QuoteServer

    public QuoteServer()

Method Detail

### viewAccepted

    public void viewAccepted(View new_view)

  Description copied from interface: `MembershipListener`
  Called when a change in membership has occurred. No long running actions or sending of messages should be done in this callback. If some long running action needs to be performed, it should be done in a separate thread.

  Note that on reception of the first view (a new member just joined), the channel will not yet be in the connected state. This only happens when `Channel.connect(String)` returns.

  Specified by:
    `viewAccepted` in interface `MembershipListener`

### suspect

    public void suspect(Address suspected_mbr)

  Description copied from interface: `MembershipListener`
  Called whenever a member is suspected of having crashed, but has not yet been excluded.

  Specified by:
    `suspect` in interface `MembershipListener`

### block

    public void block()

  Description copied from interface: `MembershipListener`
  Called (usually by the FLUSH protocol), as an indication that the member should stop sending messages. Any messages sent after returning from this callback might get blocked by the FLUSH protocol. When the FLUSH protocol is done, and messages can be sent again, the FLUSH protocol will simply unblock all pending messages. If a callback for unblocking is desired, implement `ExtendedMembershipListener.unblock()`. Note that block() is the equivalent of reception of a BlockEvent in the pull mode.

  Specified by:
    `block` in interface `MembershipListener`

### start

    public void start()

### getQuote

    public float getQuote(java.lang.String stock_name)
                   throws java.lang.Exception

  Throws:
    `java.lang.Exception`

### setQuote

    public void setQuote(java.lang.String stock_name,
                         java.lang.Float value)

### getAllStocks

    public java.util.Hashtable getAllStocks()

### printAllStocks

    public void printAllStocks()

### receive

    public void receive(Message msg)

  Description copied from interface: `MessageListener`
  Called when a message is received.

  Specified by:
    `receive` in interface `MessageListener`

### getState

    public byte[] getState()

  Description copied from interface: `MessageListener`
  Answers the group state; e.g., when joining.

  Specified by:
    `getState` in interface `MessageListener`
  Returns:
    byte[]

### setState

    public void setState(byte[] state)

  Description copied from interface: `MessageListener`
  Sets the group state; e.g., when joining.

  Specified by:
    `setState` in interface `MessageListener`

### main

    public static void main(java.lang.String[] args)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1998-2009 Bela Ban / Red Hat. All Rights Reserved.